RUSTDOC(1)

NAME
rustdoc - generate documentation from Rust source code

SYNOPSIS
rustdoc [OPTIONS] INPUT

DESCRIPTION
This tool generates API reference documentation by extracting comments from source code written in the Rust language, available at <https://www.rust-lang.org>. It accepts several input formats and provides several output formats for the generated documentation.

OPTIONS

-r --input-format <val>
    html or json (default: inferred)

-w --output-format <val>
    html or json (default: html)

-o --output <val>
    where to place the output (default: doc/ for html, doc.json for json)

--passes <val>
    space-separated list of passes to run (default: '')

--no-defaults
    don't run the default passes

--plugins <val>
    space-separated list of plugins to run (default: '')

--plugin-path <val>
    directory to load plugins from (default: /tmp/rustdoc_ng/plugins)

-L --library-path <val>
    directory to add to crate search path

--html-in-header <val>
    file to add to <head>

--html-before-content <val>
    file to add in <body>, before content

--html-after-content <val>
    file to add in <body>, after content

-h, --help
    Print help

OUTPUT FORMATS
The rustdoc tool can generate output in either an HTML or JSON format. If using an HTML format, then the specified output destination will be the root directory of an HTML structure for all the documentation. Pages will be placed into this directory, and source files will also possibly be rendered into it as well. If using a JSON format, then the specified output destination will have the rustdoc output serialized as JSON into it. This output format exists to pre-compile documentation for crates, and for usage in non-rustdoc tools. The JSON output is the following hash:
    {
        "schema": VERSION,
        "crate": ...,
        "plugins": ...,
    } The schema version indicates what the structure of crate/plugins will look like. Within a schema version the structure will remain the same. The `crate` field will contain all relevant documentation for the source being documented, and the `plugins` field will contain the output of the plugins run over the crate.

EXAMPLES
To generate documentation for the source in the current directory:
    $ rustdoc hello.rs List all available passes that rustdoc has, along with default passes:
    $ rustdoc --passes list To precompile the documentation for a crate, and then use it to render html at a later date:
    $ rustdoc -w json hello.rs
    $ rustdoc doc.json The generated HTML can be viewed with any standard web browser.

SEE ALSO
rustc

BUGS
See <https://github.com/rust-lang/rust/issues> for issues.

AUTHOR
See AUTHORS.txt in the Rust source distribution.

COPYRIGHT
This work is dual-licensed under Apache 2.0 and MIT terms. See COPYRIGHT file in the rust source distribution.